#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	libffi
Version		:	3.4.4
Release		:	14.4.0.0%{?dist}

Summary		:	A portable foreign function interface library
Group		:	Applications/libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT and Public Domain
URL		:	https://github.com/libffi/libffi/releases/tag

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
%description
The libffi library provides a portable, high level programming
interface to various calling conventions. This allows a programmer to
call any function specified by a call interface description at run
time.  

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. The
libffi library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface. A layer must
exist above libffi that handles type conversions for values passed
between the two languages.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README.md
%license LICENSE
%{_libdir}/%{name}.so.*

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and header
files for developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/ffi*.h
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/%{name}.so
%{_mandir}/man3/*.3.gz
%{_infodir}/%{name}.info.*

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)

sed -i							\
  -e '/^includesdir/ s/$(libdir).*$/$(includedir)/'	\
  include/Makefile.in
sed -i							\
  -e '/^includedir/ s/=.*$/=@includedir@/'		\
  -e 's/^Cflags: -I${includedir}/Cflags:/'		\
  libffi.pc.in

#configure with enable-portable-binary seem very important
#as without code could be executed on xeon but not on core2
#see with-gcc-arch seems to do the same things.
#	--with-gcc-arch=%{_arch}

./configure						\
        --prefix=%{_prefix}				\
	--libdir=%{_libdir}				\
	--libexecdir=%{_libexecdir}			\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--infodir=%{_infodir}				\
	--sharedstatedir=%{_var}/lib			\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-debug					\
	--disable-static				\
	--with-gcc-arch=x86_64				\
	--enable-portable-binary			\

%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%check
%{__make} check
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install


%{__rm} -fr %{buildroot}%{_infodir}/dir
#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
